﻿// yokainumend.cpp : このファイルには 'main' 関数が含まれています。プログラム実行の開始と終了がそこで行われます。
//

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

// ひとつでもアルファベットと数字が隣接している行があったら除去するツール

int main(int argc, char* argv[])
{
    FILE* fp;
    static char str[256];
    int i = 0;
    int badflag = 0;
    int option = 0, flag = 0;
    int cursor = 0;
    char hanteichar = '.';
    int mode = 0;

    if (argc == 1) {
        printf("usage:yokaisynerr.exe passwords.txt {mode(0 or 1)}\n");
        printf("mode 0 = EASY / 1 = HARD\n");
        return 0;
    }

    // passwordsオープン
    if (fopen_s(&fp, argv[1], "rt") != 0) {
        printf("Password  File %s not found.\n", argv[2]);
        _fcloseall();
        return -1;
    }
    mode = argv[2][0];


    // 行をロードしてシフトして出力
    while (fgets(str, 16, fp)) {
        badflag = 0;

        // モードゼロはチェック甘め。
        if (mode == '0') {
            // 子音+子音+子音+子音を検出
            for (i = 0; i < 11; i++) {
                // 1文字目をチェックしてAIUEO以外ならばチェックスタート
                if (str[i] != 'A' && str[i] != 'I' && str[i] != 'U' && str[i] != 'E' && str[i] != 'O') {
                    flag = 0;
                    // 子音四連のうち4文字目を
                    if (str[i + 1] != 'A' && str[i + 1] != 'I' && str[i + 1] != 'U' && str[i + 1] != 'E' && str[i + 1] != 'O') flag++;
                    if (str[i + 2] != 'A' && str[i + 2] != 'I' && str[i + 2] != 'U' && str[i + 2] != 'E' && str[i + 2] != 'O') flag++;
                    if (str[i + 3] != 'A' && str[i + 3] != 'I' && str[i + 3] != 'U' && str[i + 3] != 'E' && str[i + 3] != 'O' && str[i + 3] != 'Y') flag++;
                    // 4連発確定でバッドフラグ立てる
                    if (flag == 3) badflag = 1;
                }
            }
            // 子音三連（末尾Y以外）＋記号を検出
            for (i = 0; i < 11; i++) {
                // 1文字目をチェックしてAIUEO以外ならばチェックスタート
                if (str[i] != 'A' && str[i] != 'I' && str[i] != 'U' && str[i] != 'E' && str[i] != 'O') {
                    flag = 0;
                    if (str[i + 1] != 'A' && str[i + 1] != 'I' && str[i + 1] != 'U' && str[i + 1] != 'E' && str[i + 1] != 'O') flag++;
                    if (str[i + 2] != 'A' && str[i + 2] != 'I' && str[i + 2] != 'U' && str[i + 2] != 'E' && str[i + 2] != 'O' && str[i + 2] != 'Y') flag++;
                    if (str[i + 3] == '.' || str[i + 3] == '-' || str[i + 3] == '!') flag++;
                    // 条件達成でバッドフラグ立てる
                    if (flag == 3) badflag = 1;
                }
            }
        }

        if (mode == '1') {
            // モード1は厳格に
            // 子音+子音+子音+子音を検出
            for (i = 0; i < 11; i++) {
                // 1文字目をチェックしてAIUEO以外ならばチェックスタート
                if (str[i] != 'A' && str[i] != 'I' && str[i] != 'U' && str[i] != 'E' && str[i] != 'O') {
                    flag = 0;
                    // 子音四連のうち4文字目を
                    if (str[i + 1] >= 'B' && str[i + 1] <= 'Z') {
                        if (str[i + 1] != 'I' && str[i + 1] != 'U' && str[i + 1] != 'E' && str[i + 1] != 'O') flag++;
                    }
                    if (str[i + 2] >= 'B' && str[i + 2] <= 'Z') {
                        if (str[i + 2] != 'I' && str[i + 2] != 'U' && str[i + 2] != 'E' && str[i + 2] != 'O') flag++;
                    }
                    if (str[i + 3] >= 'B' && str[i + 3] <= 'Z') {
                        if (str[i + 3] != 'I' && str[i + 3] != 'U' && str[i + 3] != 'E' && str[i + 3] != 'O' && str[i + 4] != 'Y') flag++;
                    }
                    // 4連発確定でバッドフラグ立てる
                    if (flag == 3) badflag = 1;
                }
            }
            // 子音三連（末尾Y以外）＋記号を検出
            for (i = 0; i < 11; i++) {
                // 1文字目をチェックしてAIUEO以外ならばチェックスタート
                if (str[i] != 'A' && str[i] != 'I' && str[i] != 'U' && str[i] != 'E' && str[i] != 'O') {
                    flag = 0;
                    if (str[i + 1] >= 'B' && str[i + 1] <= 'Z') {
                        if (str[i + 1] != 'A' && str[i + 1] != 'I' && str[i + 1] != 'U' && str[i + 1] != 'E' && str[i + 1] != 'O') flag++;
                    }
                    if (str[i + 2] >= 'B' && str[i + 2] <= 'Z') {
                        if (str[i + 2] != 'A' && str[i + 2] != 'I' && str[i + 2] != 'U' && str[i + 2] != 'E' && str[i + 2] != 'O' && str[i + 2] != 'Y') flag++;
                    }
                    if (str[i + 3] >= 'B' && str[i + 3] <= 'Z') {
                        if (str[i + 3] == '.' || str[i + 3] == '-' || str[i + 3] == '!') flag++;
                    }
                    // 条件達成でバッドフラグ立てる
                    if (flag == 3) badflag = 1;
                }
            }
        }


        // 最終判定を突破して初めて出力
        if (!badflag) {
            printf("%s", str);
        }
    }

    _fcloseall();
    return 0;
}
