﻿#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

// ひとつでもアルファベットと数字が隣接している行があったら除去するツール

int main(int argc, char* argv[])
{
    FILE* fp;
    static char str[256];
    int i = 0;
    int badflag = 0;
    int option = 0,flag=0;


    if (argc == 1) {
        printf("usage:yokairincut.exe passwords.txt {op(2進00000-11111)}\n");
        return 0;
    }

    if (argc == 2) {
        option = 0;
    }
    else {
        option = (int)strtol(argv[2], NULL, 2);
    }

    // passwordsオープン
    if (fopen_s(&fp, argv[1], "rt") != 0) {
        printf("Password  File %s not found.\n", argv[2]);
        _fcloseall();
        return -1;
    }

    // 行をロードしてシフトして出力
    while (fgets(str, 16, fp)) {
        badflag = 0;

        if (option & 0x01) {
            for (i = 0; i < 13; i++) {
                // 数字を起点に次の文字がA～Zならキャンセル
                if (str[i] >= '0' && str[i] <= '9') {
                    if (str[i + 1] >= 'A' && str[i + 1] <= 'Z') {
                        badflag = 1;
                        break;
                    }
                }
                // アルファベットを起点に次の文字が数字ならキャンセル
                if (str[i] >= 'A' && str[i] <= 'Z') {
                    if (str[i + 1] >= '0' && str[i + 1] <= '9') {
                        badflag = 1;
                        break;
                    }
                }
            }
        }
        
        // bit1=1は数字の出現しない行を全除去
        if (option & 0x02) {
            flag = 0;
            for (i = 0; i < 14; i++) {
                if (str[i] >= '0' && str[i] <= '9') {
                    flag = 1;
                    break;
                }
            }
            if (!flag) badflag = 1;
        }
        // bit2=1はハイフンが出たら消去
        if (option & 0x04) {
            flag = 0;
            for (i = 0; i < 14; i++) {
                if (str[i] == '-') {
                    flag = 1;
                    break;
                }
            }
            if (flag) badflag = 1;
        }
        // bit3=1はドットが出たら消去
        if (option & 0x08) {
            flag = 0;
            for (i = 0; i < 14; i++) {
                if (str[i] == '.') {
                    flag = 1;
                    break;
                }
            }
            if (flag) badflag = 1;
        }
        // bit=1はエクスクラメーション！が出たら消去
        if (option & 0x10) {
            flag = 0;
            for (i = 0; i < 14; i++) {
                if (str[i] == '!') {
                    flag = 1;
                    break;
                }
            }
            if (flag) badflag = 1;
        }

        // badflagの立っていないパスワードだけ出力
        if(!badflag) printf("%s", str);

    }

    _fcloseall();
    return 0;
}